/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Vivek K S

#ifndef _AC_H_
#define _AC_H_

#define MAX_KEYS 8
static window *ac_keypress_list[MAX_KEYS];

static window *ac_create_new_window (wm *wm, Window map_window);
static void ac_adopt_existing(wm *wm);

// Event handlers
static void ac_handle_map_request(wm *wm, XMapEvent *xev, window *w);
static void ac_handle_unmap_notify(wm *wm, XUnmapEvent *xev, window *w);
static void ac_handle_destroy_notify(wm *wm, XEvent *xev, window *w);
static void ac_handle_widget_event(wm *wm, XEvent *xev, window *w, event_area where);
static void ac_handle_button_press(wm *wm, XEvent *xev, window *w, event_area where);
//static void ac_handle_key_press(wm *wm, XKeyEvent *xev);
//static void ac_handle_key_release(wm *wm, XKeyEvent *xev);
static void ac_handle_key_press(wm *wm, XEvent *xev);
static void ac_handle_key_release(wm *wm, XEvent *xev);

static void ac_handle_configure_request(wm *wm, XConfigureRequestEvent *xev, window *w, event_area where);
static void ac_handle_configure_notify(wm *wm, XConfigureEvent *xev);
static void ac_handle_client_message(wm *wm, XClientMessageEvent *xev);
static void ac_handle_property_notify(wm *wm, XPropertyEvent *xev, window *w);
static void ac_init_keys(wm *wm);
static Bool ac_printer_status();

#define AC_HANDLE_VAR_CHANGE_CMD(atomindex, winvar, refresh) { \
			char data[MAX_PROPERTY_LENGTH]; \
			\
			window_get_text_property(clientwin, (atomindex), data); \
			if(data[0] == 0) { \
				debug_info("Unable to extract the command arguement\n"); \
			} else { \
				DBG(debug_info("data = %s \n", data);)\
				if(clientwin->winvar) \
					free(clientwin->winvar); \
				clientwin->winvar = (char *)malloc(strlen(data) + 1); \
				if(!clientwin->winvar) \
					err_exit("%s(): Unable to allocate memory", __func__); \
				strcpy(clientwin->winvar, data); \
				if((refresh) == 1) \
					clientwin->redraw(clientwin); \
			} \
		}

#endif
