/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Vivek K S

#ifndef _ACCTRL_H_
#define _ACCTRL_H_

#ifdef __cplusplus
extern "C" {
#endif

/* Commands for whom property change is required */

#define AC_CMD_SET_THEME                  1
#define AC_CMD_EXIT                       2
#define AC_CMD_NEXT                       3
#define AC_CMD_PREV                       4

#define AC_CMD_SET_FLAGS                  5
#define AC_CMD_LAUNCH_APP                 6
#define AC_CMD_SET_TITLE_FONT             7
#define AC_CMD_SET_TITLE_JUSTIFY          8

#define AC_CMD_SET_STATUS_MSG            9
#define AC_CMD_SET_STATUS_FONT           10
#define AC_CMD_SET_STATUS_JUSTIFY        11
#define AC_CMD_SET_PAGE_NUM              12
#define AC_CMD_SET_PAGE_NUM_FONT         13
#define AC_CMD_SET_PAGE_NUM_JUSTIFY      14
#define AC_CMD_SET_KEYBOARD_LAYOUT       15
#define AC_CMD_SET_KEYBOARD_CATEGORY     16
#define AC_CMD_SET_ANNOTATE_KEY          17
#define AC_CMD_SET_HELP_KEY              18

#define AC_CMD_SET_EMAIL_FILE            19
#define AC_CMD_DEL_ANNOTATION            20

#ifdef __arm__
#define AC_CMD_SET_ROTATION              21
#endif

/* Odd men out */
#define AC_CMD_LAYER_NEXT_APP	30 
#define AC_CMD_LAYER_THIS_WIN	31

/* The following commands need not require change property. */

#define AC_CMD_SHOW_INPUT 51
#define AC_CMD_HIDE_INPUT 52

#define AC_CMD_SHOW_ANNOTATE 53
#define AC_CMD_HIDE_ANNOTATE 54

#define AC_CMD_SHOW_EMAIL    55
#define AC_CMD_HIDE_EMAIL    56

#define AC_CMD_SHOW_PRINTER  57
#define AC_CMD_HIDE_PRINTER  58

#define AC_CMD_SHOW_PAGE_NAV  59
#define AC_CMD_HIDE_PAGE_NAV  60

#define AC_CMD_ENABLE_PAGE_NEXT 61
#define AC_CMD_DISABLE_PAGE_NEXT 62

#define AC_CMD_ENABLE_PAGE_PREV 63
#define AC_CMD_DISABLE_PAGE_PREV 64

#define AC_CMD_SHOW_RETRACTBAR 65
#define AC_CMD_HIDE_RETRACTBAR 66

#define AC_CMD_SHOW_KEYBOARD 67
#define AC_CMD_HIDE_KEYBOARD 68

#define AC_CMD_SHOW_STATUS 69
#define AC_CMD_HIDE_STATUS 70

#define AC_CMD_SWAP_CLOSE_UP 71
#define AC_CMD_SHOW_CLOSE	 72
#define AC_CMD_SHOW_UP		 73

#define AC_CMD_PRINTER_STATUS 74

#define AC_CMD_SHOW_SPEAKER 75
#define AC_CMD_HIDE_SPEAKER 76

#define AC_CMD_SHOW_VOICE 77
#define AC_CMD_HIDE_VOICE 78

#define AC_CMD_APP_SPEAKS 79
#define AC_CMD_AC_SPEAKS  80

#define AC_CMD_SHOW_TICK	81

#define AC_CMD_SHOW_HELP	82
#define AC_CMD_HIDE_HELP	83

#define AC_CMD_GRAB_ON		84
#define AC_CMD_GRAB_OFF		85

#define _NET_WM_STATE_REMOVE        0    /* remove/unset property */
#define _NET_WM_STATE_ADD           1    /* add/set property */
#define _NET_WM_STATE_TOGGLE        2    /* toggle property  */


unsigned long getWindowAppid(Window win, Display *dpy);
void getRootProperty(char * name, Bool del, Display *dpy);
void ac_control_win(int cmd_id, char *data, Display *dpy, Window win);
void ewmh_command_win(char *cmd_atom_str, int sub_cmd, Display *dpy, Window win);
void ewmh_command(char *cmd_atom_str, int sub_cmd, Display *dpy);
void ac_init_app(Display *, Window );

#ifdef __cplusplus
}
#endif

#endif
