/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Vivek K S

#include <X11/Xlib.h>
#include <X11/Xatom.h>

#include "alchemy.h"
#include "ewmh.h"
#include "basic_window.h"
#include "normal_window.h"
#include "utils.h"


void ac_ewmh_set_active_window(wm *wm)
{
	unsigned long val[1];
	
	if(wm->mapped_window)
		val[0] = wm->mapped_window->app_window;
	else
		val[0] = None;

	XChangeProperty(wm->display, wm->root,
			wm->atomlist[_NET_ACTIVE_WINDOW],
			XA_WINDOW, 32, PropModeReplace, (unsigned char *)val, 1);
	XFlush(wm->display);
}

void ac_ewmh_handle_clientmessage(wm *wm, XClientMessageEvent *xev, window *clientwin)
{
	DBG(debug_info("got ewmh message");)
	if(xev->message_type == wm->atomlist[_NET_CLOSE_WINDOW]) {
		if(clientwin)
			window_handle_deletion(clientwin);
	} else if (xev->message_type == wm->atomlist[_NET_ACTIVE_WINDOW]) {
		if(clientwin && clientwin != wm->mapped_window) {
			window *old_mapped_window;

			old_mapped_window = wm->mapped_window;
			clientwin->show(clientwin);
			if(old_mapped_window && old_mapped_window != wm->mapped_window)
				old_mapped_window->hide(old_mapped_window);
		}
	} else if (xev->message_type == wm->atomlist[_NET_WM_STATE]) {
		if(xev->data.l[0] == wm->atomlist[_NET_WM_STATE_FULLSCREEN]) {
			if(!clientwin)
				clientwin = wm->mapped_window;

			if(clientwin && clientwin->wtype == NORMAL_WIN) {
				if(xev->data.l[2] == _NET_WM_STATE_TOGGLE) {
					if(clientwin->flags.bits.full_screen)
						clientwin->set_flag(clientwin, FULL_SCREEN, False);
					else
						clientwin->set_flag(clientwin, FULL_SCREEN, True);
					normal_window_handle_full_screen(clientwin);
				}
			}
		}
	}
}
